﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=10.7
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
	#ExcludeFromLibrary: True
	#StartCommandReturnValue: android.app.Service.START_STICKY
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Private FusedLocationProvider1 As FusedLocationProvider
	Private LastLocation As Location
	
	Public Notifica As Boolean
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	
	Try
		FusedLocationProvider1.Initialize("FusedLocationProvider1")
	Catch
		ToastMessageShow("Wallpaper ServiceCreate: " & LastException, True)
	End Try	
	
	Notifica = True
End Sub

Sub Service_Start (StartingIntent As Intent)
	'Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
	'Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_ALWAYS
	Log("Service: Busca cercanos: On")	
	
	Try		
		FusedLocationProvider1.Connect
	Catch
		ToastMessageShow("Wallpaper ServiceStart: " & LastException, True)
	End Try	

	StartServiceAt(Me, DateTime.Now + (30 * 1000), True)
End Sub

Sub Service_Destroy
	FusedLocationProvider1.Disconnect
	StartServiceAt(Me, DateTime.Now + (60 * 1000), True)
End Sub

Sub FusedLocationProvider1_ConnectionFailed(ConnectionResult1 As Int)
	Log("FusedLocationProvider1_ConnectionFailed")
	
	'	the FusedLocationProvider ConnectionResult object contains the various CoonectionResult constants
	
	Select ConnectionResult1
		Case FusedLocationProvider1.ConnectionResult.NETWORK_ERROR
			'	a network error has occurred, this is likely to be a recoverable error
			'	so try to connect again
			FusedLocationProvider1.Connect
		Case Else
			'	TODO handle other errors
	End Select
End Sub

Sub FusedLocationProvider1_ConnectionSuccess
	Log("FusedLocationProvider1_ConnectionSuccess")
	Dim LocationRequest1 As LocationRequest
	LocationRequest1.Initialize
	LocationRequest1.SetInterval(5000)	'	1000 milliseconds
	LocationRequest1.SetPriority(LocationRequest1.Priority.PRIORITY_HIGH_ACCURACY)
	LocationRequest1.SetSmallestDisplacement(1)	'	1 meter
	FusedLocationProvider1.RequestLocationUpdates(LocationRequest1)
End Sub

Sub FusedLocationProvider1_ConnectionSuspended(SuspendedCause1 As Int)
	Log("FusedLocationProvider1_ConnectionSuspended")
	
	'	the FusedLocationProvider SuspendedCause object contains the various SuspendedCause constants
	
	Select SuspendedCause1
		Case FusedLocationProvider1.SuspendedCause.CAUSE_NETWORK_LOST
			'	TODO take action
		Case FusedLocationProvider1.SuspendedCause.CAUSE_SERVICE_DISCONNECTED
			'	TODO take action
	End Select
End Sub

Sub FusedLocationProvider1_LocationChanged(Location1 As Location)
	Log("FusedLocationProvider1_LocationChanged")
	LastLocation=Location1
	UpdateUI		
	CallSubDelayed2(Main, "Gps_LocationChanged", Location1)
End Sub

Sub UpdateUI
	Dim Report As String = DateTime.Time(LastLocation.Time)&" ("&LastLocation.Latitude&", "&LastLocation.Longitude&")"
	functions.Notifica("Location", Report, False, 1)
End Sub